diff -crN gimp-1.0.0.orig/app/about_dialog.c gimp-1.0.0/app/about_dialog.c
*** gimp-1.0.0.orig/app/about_dialog.c	Sat May 30 15:31:54 1998
--- gimp-1.0.0/app/about_dialog.c	Fri Sep 11 22:41:08 1998
***************
*** 24,29 ****
--- 24,33 ----
  
  #include "config.h"
  
+ #ifdef __EMX__
+ extern const char *__XOS2RedirRoot(const char *);
+ #endif
+ 
  #define ANIMATION_STEPS 16
  #define ANIMATION_SIZE 2
  
***************
*** 281,287 ****
--- 285,295 ----
    if (logo_pixmap)
      return TRUE;
  
+ #ifndef __EMX__
    sprintf (buf, "%s/gimp_logo.ppm", DATADIR);
+ #else
+   sprintf (buf, "%s/gimp_logo.ppm", __XOS2RedirRoot(DATADIR));
+ #endif
  
    fp = fopen (buf, "rb");
    if (!fp)
diff -crN gimp-1.0.0.orig/app/app_procs.c gimp-1.0.0/app/app_procs.c
*** gimp-1.0.0.orig/app/app_procs.c	Sat May 30 15:31:56 1998
--- gimp-1.0.0/app/app_procs.c	Fri Jul 10 14:49:54 1998
***************
*** 59,64 ****
--- 59,68 ----
  
  #include "config.h"
  
+ #ifdef __EMX__
+ extern const char *__XOS2RedirRoot(const char *);
+ #endif
+ 
  #define LOGO_WIDTH_MIN 350
  #define LOGO_HEIGHT_MIN 110 
  #define NAME "The GIMP"
***************
*** 149,155 ****
--- 153,163 ----
    if (logo_pixmap)
      return TRUE;
  
+ #ifndef __EMX__
    sprintf (buf, "%s/gimp_splash.ppm", DATADIR);
+ #else
+   sprintf (buf, "%s/gimp_splash.ppm", __XOS2RedirRoot(DATADIR));
+ #endif
  
    fp = fopen (buf, "r");
    if (!fp)
***************
*** 184,190 ****
--- 192,202 ----
    if (logo_pixmap)
      return TRUE;
  
+ #ifndef __EMX__
    sprintf (buf, "%s/gimp_splash.ppm", DATADIR);
+ #else
+   sprintf (buf, "%s/gimp_splash.ppm", __XOS2RedirRoot(DATADIR));
+ #endif
  
    fp = fopen (buf, "r");
    if (!fp)
diff -crN gimp-1.0.0.orig/app/datafiles.c gimp-1.0.0/app/datafiles.c
*** gimp-1.0.0.orig/app/datafiles.c	Thu May 28 17:03:04 1998
--- gimp-1.0.0/app/datafiles.c	Sat Jul 11 14:52:18 1998
***************
*** 70,76 ****
--- 70,80 ----
  
    next_token = local_path;
  
+ #ifndef __EMX__
    token = xstrsep(&next_token, ":");
+ #else
+   token = xstrsep(&next_token, ";");
+ #endif
  
    while (token)
      {
***************
*** 126,132 ****
--- 130,140 ----
  
        g_free(path);
  
+ #ifndef __EMX__
        token = xstrsep(&next_token, ":");
+ #else
+       token = xstrsep(&next_token, ";");
+ #endif
      } /* while */
  
    g_free(local_path);
diff -crN gimp-1.0.0.orig/app/general.c gimp-1.0.0/app/general.c
*** gimp-1.0.0.orig/app/general.c	Mon Apr 13 13:38:30 1998
--- gimp-1.0.0/app/general.c	Sat Jul 11 14:52:48 1998
***************
*** 50,56 ****
--- 50,60 ----
    int err;
  
    local_path = g_strdup (search_path);
+ #ifndef __EMX__
    token = strtok (local_path, ":");
+ #else
+   token = strtok (local_path, ";");
+ #endif
  
    while (token)
      {
***************
*** 67,73 ****
--- 71,81 ----
  	  break;
  	}
  
+ #ifndef __EMX__
        token = strtok (NULL, ":");
+ #else
+       token = strtok (NULL, ";");
+ #endif
      }
  
    g_free (local_path);
diff -crN gimp-1.0.0.orig/app/gimp2.def gimp-1.0.0/app/gimp2.def
*** gimp-1.0.0.orig/app/gimp2.def	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/app/gimp2.def	Sun Sep 13 03:29:24 1998
***************
*** 0 ****
--- 1,3 ----
+ NAME WINDOWCOMPAT
+ DESCRIPTION 'GIMP/2 for XFree86/OS2 v1.0.0'
+ STACKSIZE 1048576
diff -crN gimp-1.0.0.orig/app/gimprc.c gimp-1.0.0/app/gimprc.c
*** gimp-1.0.0.orig/app/gimprc.c	Sat May 30 15:32:06 1998
--- gimp-1.0.0/app/gimprc.c	Sat Jul 11 19:23:16 1998
***************
*** 33,38 ****
--- 33,42 ----
  #include "plug_in.h"
  #include "gimage.h"
  
+ #ifdef __EMX__
+ extern const char *__XOS2RedirRoot(const char *);
+ #endif
+ 
  #define ERROR  0
  #define DONE   1
  #define OK     2
***************
*** 158,163 ****
--- 162,170 ----
  static void gimprc_set_token (char *token, char *value);
  static Argument * gimprc_query (Argument *args);
  static void add_gimp_directory_token (char *gimp_dir);
+ #ifdef __EMX__
+ static void add_x11root_token (char *x11root);
+ #endif
  static char* open_backup_file (char *filename, FILE **fp_new, FILE **fp_old);
  
  static ParseInfo parse_info;
***************
*** 243,249 ****
--- 250,260 ----
  
    if (NULL != env_gimp_dir)
      {
+ #ifndef __EMX__
        if ('/' == env_gimp_dir[0])
+ #else
+       if (_fnisabs(env_gimp_dir))
+ #endif
  	  strncpy (gimp_dir, env_gimp_dir, MAX_GIMPDIR_LEN);
        else
  	{
***************
*** 293,300 ****
--- 304,318 ----
  
    gimp_dir = gimp_directory ();
    add_gimp_directory_token (gimp_dir);
+ #ifdef __EMX__
+   add_x11root_token(getenv("X11ROOT"));
+ #endif
  
+ #ifndef __EMX__
    sprintf (libfilename, "%s/gimprc", DATADIR);
+ #else
+   sprintf (libfilename, "%s/gimprc", __XOS2RedirRoot(DATADIR));
+ #endif
    app_init_update_status("Resource configuration", libfilename, -1);
    parse_gimprc_file (libfilename);
  
***************
*** 313,319 ****
--- 331,341 ----
    int status;
    char rfilename[512];
  
+ #ifndef __EMX__
    if (filename[0] != '/')
+ #else
+   if (_fnisrel(filename))
+ #endif
      {
        if (!home_dir)
  	home_dir = g_strdup (getenv ("HOME"));
***************
*** 1745,1750 ****
--- 1767,1797 ----
    unknown_tokens = g_list_append (unknown_tokens, ut);
  }
  
+ #ifdef __EMX__
+ static void
+ add_x11root_token (char *x11root)
+ {
+   UnknownToken *ut;
+ 
+   if (x11root == NULL)
+     return;
+   /*
+     The token holds data from a static buffer which is initialized
+     once.  There should be no need to change an already-existing
+     value.
+   */
+   if (NULL != gimprc_find_token ("x11root"))
+     return;
+ 
+   ut = g_new (UnknownToken, 1);
+   ut->token = g_strdup ("x11root");
+   ut->value = g_strdup (x11root);
+ 
+   /* Similarly, transforming the path should be silly. */
+   unknown_tokens = g_list_append (unknown_tokens, ut);
+ }
+ #endif
+ 
  /* Try to:
  
     1. Open gimprc for reading.
***************
*** 1778,1783 ****
--- 1825,1839 ----
  
    oldfilename = g_malloc (strlen (filename) + 5);
    sprintf (oldfilename, "%s.old", filename);
+ #ifdef __EMX__
+   {
+     struct stat buf;
+ 
+     if (stat (oldfilename, &buf) == 0)	/* if .old exists, remove it */
+       remove(oldfilename);
+     fclose(*fp_old);	/* before rename(), close it */
+   }
+ #endif
    if (rename (filename, oldfilename) < 0)
      {
        g_free (oldfilename);
***************
*** 1787,1792 ****
--- 1843,1859 ----
          return "Can't rename gimprc to gimprc.old; gimprc.old is a directory";
        return "Can't rename gimprc to gimprc.old, reason unknown";
      }
+ #ifdef __EMX__
+   /* reopen */
+   if ((*fp_old = fopen (oldfilename, "rt")) == NULL)
+     {
+       if (errno == EACCES)
+         return "Can't open gimprc; permission problems";
+       if (errno == ENOENT)
+         return "Can't open gimprc; file does not exist";
+       return "Can't open gimprc, reason unknown";
+     }
+ #endif
  
    if ((*fp_new = fopen (filename, "wt")) == NULL)
      {
diff -crN gimp-1.0.0.orig/app/gradient.c gimp-1.0.0/app/gradient.c
*** gimp-1.0.0.orig/app/gradient.c	Thu May 28 17:03:18 1998
--- gimp-1.0.0/app/gradient.c	Fri Jul 10 19:48:36 1998
***************
*** 5837,5843 ****
--- 5837,5847 ----
  	home        = getenv("HOME");
  	local_path  = g_strdup(path_str);
  	first_token = local_path;
+ #ifndef __EMX__
  	token       = xstrsep(&first_token, ":");
+ #else
+ 	token       = xstrsep(&first_token, ";");
+ #endif
  	filename    = NULL;
  
  	if (token) {
diff -crN gimp-1.0.0.orig/app/Imakefile gimp-1.0.0/app/Imakefile
*** gimp-1.0.0.orig/app/Imakefile	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/app/Imakefile	Thu Jul 30 00:30:46 1998
***************
*** 0 ****
--- 1,286 ----
+ /*
+     Written for XFree86/OS2
+     Hung-Chi Chu <hcchu@r350.ee.ntu.edu.tw> 07/09/1998
+  */
+ 
+ #include "../gimp.cf"
+ 
+ #if BuildOMFEXE
+ ADD_DEFS = -Zomf
+ LOCAL_LDFLAGS = -Zomf
+ PROG_DEF = gimp2.def
+ #else
+ ADD_DEFS =
+ LOCAL_LDFLAGS = 
+ PROG_DEF =
+ #endif
+ 
+ DEFINES = \
+ 	-DHAVE_CONFIG_H \
+ 	-DLIBDIR=\""$(GIMPPLUGINSDIR)"\" \
+ 	-DDATADIR=\""$(GIMPDATADIR)"\" \
+ 	-DGIMPDIR=\"".gimp"\" $(ADD_DEFS)
+ 
+ INCLUDES = -I.. -I.
+ 
+ #ifdef OS2Architecture
+ LOCAL_LIBRARIES = -L../libgimp -lgimp -lgtk -lgdk -lglib -lXext -lX11 -lshm
+ #else
+ LOCAL_LIBRARIES = -L../libgimp -lgimp -lgtk -lgdk -lglib -lXext -lX11
+ #endif
+ 
+ SRCS = \
+ 	about_dialog.c		\
+ 	actionarea.c		\
+ 	airbrush.c		\
+ 	app_procs.c		\
+ 	asupsample.c		\
+ 	batch.c			\
+ 	bezier_select.c		\
+ 	blend.c			\
+ 	boundary.c		\
+ 	brightness_contrast.c	\
+ 	brush_select.c		\
+ 	brushes.c		\
+ 	bucket_fill.c		\
+ 	buildmenu.c		\
+ 	by_color_select.c	\
+ 	channel.c		\
+ 	channel_cmds.c		\
+ 	channels_dialog.c	\
+ 	channel_ops.c		\
+ 	clone.c			\
+ 	color_area.c		\
+ 	color_balance.c		\
+ 	color_panel.c		\
+ 	color_picker.c		\
+ 	color_select.c		\
+ 	color_transfer.c	\
+ 	colormaps.c		\
+ 	commands.c		\
+ 	convert.c		\
+ 	convolve.c		\
+ 	crop.c			\
+ 	cursorutil.c		\
+ 	curves.c		\
+ 	datafiles.c		\
+ 	desaturate.c		\
+ 	disp_callbacks.c	\
+ 	draw_core.c		\
+ 	drawable.c		\
+ 	drawable_cmds.c		\
+ 	edit_cmds.c		\
+ 	edit_selection.c	\
+ 	ellipse_select.c	\
+ 	eraser.c		\
+ 	errors.c		\
+ 	equalize.c		\
+ 	fileops.c		\
+ 	flip_tool.c		\
+ 	floating_sel.c		\
+ 	floating_sel_cmds.c	\
+ 	frac.c			\
+ 	free_select.c		\
+ 	fuzzy_select.c		\
+ 	gdisplay.c		\
+ 	gdisplay_cmds.c		\
+ 	gdisplay_ops.c		\
+ 	general.c		\
+ 	gimage.c		\
+ 	gimage_cmds.c		\
+ 	gimage_mask.c		\
+ 	gimage_mask_cmds.c	\
+ 	gimprc.c		\
+ 	global_edit.c		\
+ 	gradient.c		\
+ 	gximage.c		\
+ 	histogram.c		\
+ 	histogram_tool.c	\
+ 	hue_saturation.c	\
+ 	image_map.c		\
+ 	image_render.c		\
+ 	indexed_palette.c	\
+ 	info_dialog.c		\
+ 	info_window.c		\
+ 	install.c		\
+ 	interface.c		\
+ 	internal_procs.c	\
+ 	invert.c		\
+ 	iscissors.c		\
+ 	layer.c			\
+ 	layer_cmds.c		\
+ 	layer_select.c		\
+ 	layers_dialog.c		\
+ 	levels.c		\
+ 	magnify.c		\
+ 	main.c			\
+ 	menus.c			\
+ 	move.c			\
+ 	ops_buttons.c		\
+ 	palette.c		\
+ 	paint_core.c		\
+ 	paint_funcs.c		\
+ 	paintbrush.c		\
+ 	pattern_select.c	\
+ 	patterns.c		\
+ 	pencil.c		\
+ 	perspective_tool.c	\
+ 	pixel_region.c		\
+ 	plug_in.c		\
+ 	posterize.c		\
+ 	procedural_db.c		\
+ 	rect_select.c		\
+ 	regex.c			\
+ 	resize.c		\
+ 	rotate_tool.c		\
+ 	scale.c			\
+ 	scale_tool.c		\
+ 	scroll.c		\
+ 	selection.c		\
+ 	shear_tool.c		\
+ 	temp_buf.c		\
+ 	text_tool.c		\
+ 	threshold.c		\
+ 	tile.c			\
+ 	tile_cache.c		\
+ 	tile_manager.c		\
+ 	tile_swap.c		\
+ 	tips_dialog.c		\
+ 	tools.c			\
+ 	transform_core.c	\
+ 	transform_tool.c	\
+ 	undo.c			\
+ 	undo_cmds.c		\
+ 	xcf.c
+ 
+ OBJS = \
+ 	about_dialog.o		\
+ 	actionarea.o		\
+ 	airbrush.o		\
+ 	app_procs.o		\
+ 	asupsample.o		\
+ 	batch.o			\
+ 	bezier_select.o		\
+ 	blend.o			\
+ 	boundary.o		\
+ 	brightness_contrast.o	\
+ 	brush_select.o		\
+ 	brushes.o		\
+ 	bucket_fill.o		\
+ 	buildmenu.o		\
+ 	by_color_select.o	\
+ 	channel.o		\
+ 	channel_cmds.o		\
+ 	channels_dialog.o	\
+ 	channel_ops.o		\
+ 	clone.o			\
+ 	color_area.o		\
+ 	color_balance.o		\
+ 	color_panel.o		\
+ 	color_picker.o		\
+ 	color_select.o		\
+ 	color_transfer.o	\
+ 	colormaps.o		\
+ 	commands.o		\
+ 	convert.o		\
+ 	convolve.o		\
+ 	crop.o			\
+ 	cursorutil.o		\
+ 	curves.o		\
+ 	datafiles.o		\
+ 	desaturate.o		\
+ 	disp_callbacks.o	\
+ 	draw_core.o		\
+ 	drawable.o		\
+ 	drawable_cmds.o		\
+ 	edit_cmds.o		\
+ 	edit_selection.o	\
+ 	ellipse_select.o	\
+ 	eraser.o		\
+ 	errors.o		\
+ 	equalize.o		\
+ 	fileops.o		\
+ 	flip_tool.o		\
+ 	floating_sel.o		\
+ 	floating_sel_cmds.o	\
+ 	frac.o			\
+ 	free_select.o		\
+ 	fuzzy_select.o		\
+ 	gdisplay.o		\
+ 	gdisplay_cmds.o		\
+ 	gdisplay_ops.o		\
+ 	general.o		\
+ 	gimage.o		\
+ 	gimage_cmds.o		\
+ 	gimage_mask.o		\
+ 	gimage_mask_cmds.o	\
+ 	gimprc.o		\
+ 	global_edit.o		\
+ 	gradient.o		\
+ 	gximage.o		\
+ 	histogram.o		\
+ 	histogram_tool.o	\
+ 	hue_saturation.o	\
+ 	image_map.o		\
+ 	image_render.o		\
+ 	indexed_palette.o	\
+ 	info_dialog.o		\
+ 	info_window.o		\
+ 	install.o		\
+ 	interface.o		\
+ 	internal_procs.o	\
+ 	invert.o		\
+ 	iscissors.o		\
+ 	layer.o			\
+ 	layer_cmds.o		\
+ 	layer_select.o		\
+ 	layers_dialog.o		\
+ 	levels.o		\
+ 	magnify.o		\
+ 	main.o			\
+ 	menus.o			\
+ 	move.o			\
+ 	ops_buttons.o		\
+ 	palette.o		\
+ 	paint_core.o		\
+ 	paint_funcs.o		\
+ 	paintbrush.o		\
+ 	pattern_select.o	\
+ 	patterns.o		\
+ 	pencil.o		\
+ 	perspective_tool.o	\
+ 	pixel_region.o		\
+ 	plug_in.o		\
+ 	posterize.o		\
+ 	procedural_db.o		\
+ 	rect_select.o		\
+ 	regex.o			\
+ 	resize.o		\
+ 	rotate_tool.o		\
+ 	scale.o			\
+ 	scale_tool.o		\
+ 	scroll.o		\
+ 	selection.o		\
+ 	shear_tool.o		\
+ 	temp_buf.o		\
+ 	text_tool.o		\
+ 	threshold.o		\
+ 	tile.o			\
+ 	tile_cache.o		\
+ 	tile_manager.o		\
+ 	tile_swap.o		\
+ 	tips_dialog.o		\
+ 	tools.o			\
+ 	transform_core.o	\
+ 	transform_tool.o	\
+ 	undo.o			\
+ 	undo_cmds.o		\
+ 	xcf.o			\
+ 	$(PROG_DEF)
+ 
+ ComplexProgramTarget(gimp)
+ 
+ #if defined(OS2Architecture) && !BuildOMFEXE
+ all::
+ 	emxbind -a gimp.exe -h255
+ #endif
diff -crN gimp-1.0.0.orig/app/install.c gimp-1.0.0/app/install.c
*** gimp-1.0.0.orig/app/install.c	Sat May 30 15:32:10 1998
--- gimp-1.0.0/app/install.c	Sun Sep 13 02:15:56 1998
***************
*** 27,32 ****
--- 27,36 ----
  #include "gimprc.h"
  
  
+ #ifdef __EMX__
+ extern const char *__XOS2RedirRoot(const char *);
+ #endif
+ 
  static void install_run (InstallCallback);
  static void install_help (InstallCallback);
  static void help_install_callback (GtkWidget *, gpointer);
***************
*** 415,421 ****
--- 419,429 ----
    gtk_text_insert (GTK_TEXT (text), font_strong, NULL, NULL, "User Installation Log\n\n", -1);
  
    /*  Generate output  */
+ #ifndef __EMX__
    sprintf (buffer, "%s/user_install", DATADIR);
+ #else
+   sprintf (buffer, "%s/user_install.cmd", __XOS2RedirRoot(DATADIR));
+ #endif
    if ((err = stat (buffer, &stat_buf)) != 0)
      {
        gtk_text_insert (GTK_TEXT (text), font, NULL, NULL, buffer, -1);
***************
*** 433,440 ****
--- 441,458 ----
  
    if (executable == TRUE)
      {
+ #ifndef __EMX__
        sprintf (buffer, "%s/user_install %s %s", DATADIR, DATADIR,
  	       gimp_directory ());
+ #else
+       char *s = buffer;
+       sprintf (buffer, "%s/user_install.cmd %s %s", __XOS2RedirRoot(DATADIR),
+ 	       __XOS2RedirRoot(DATADIR), gimp_directory ());
+       while (*s)
+ 	{
+ 	  if (*s == '/') *s = '\\'; s++;
+ 	}
+ #endif
        if ((pfp = popen (buffer, "r")) != NULL)
  	{
  	  while (fgets (buffer, 2048, pfp))
diff -crN gimp-1.0.0.orig/app/palette.c gimp-1.0.0/app/palette.c
*** gimp-1.0.0.orig/app/palette.c	Thu May 28 17:03:30 1998
--- gimp-1.0.0/app/palette.c	Sat Sep 12 21:27:38 1998
***************
*** 971,977 ****
--- 971,981 ----
  	  home = getenv("HOME");
  	  local_path = g_strdup (palette_path);
  	  first_token = local_path;
+ #ifndef __EMX__
  	  token = xstrsep(&first_token, ":");
+ #else
+ 	  token = xstrsep(&first_token, ";");
+ #endif
  
  	  if (token)
  	    {
***************
*** 1005,1011 ****
--- 1009,1018 ----
        palette_entries_list = palette_entries_insert_list (palette_entries_list, entries);
  
        gtk_option_menu_remove_menu (GTK_OPTION_MENU (palette->option_menu));
+ #if 0
+ /* XXX unknown bug??? */
        gtk_widget_destroy (palette->menu);
+ #endif
        palette_create_palette_menu (palette, entries);
      }
  }
***************
*** 1034,1040 ****
--- 1041,1050 ----
  	}
  
        gtk_option_menu_remove_menu (GTK_OPTION_MENU (palette->option_menu));
+ #if 0
+ /* XXX unknown bug??? */
        gtk_widget_destroy (palette->menu);
+ #endif
  
        entries = palette->entries;
        if (entries && entries->filename)
diff -crN gimp-1.0.0.orig/app/plug_in.c gimp-1.0.0/app/plug_in.c
*** gimp-1.0.0.orig/app/plug_in.c	Sat May 30 15:32:16 1998
--- gimp-1.0.0/app/plug_in.c	Sat Jul 11 15:20:54 1998
***************
*** 30,35 ****
--- 30,39 ----
  #include <sys/stat.h>
  #include <time.h>
  #include <unistd.h>
+ #ifdef __EMX__
+ #include <fcntl.h>
+ #include <process.h>
+ #endif
  
  #include "libgimp/gimpprotocol.h"
  #include "libgimp/gimpwire.h"
***************
*** 265,271 ****
--- 269,279 ----
    /* read the pluginrc file for cached data */
    if (pluginrc_path)
      {
+ #ifndef __EMX__
        if (*pluginrc_path == '/')
+ #else
+       if (_fnisabs(pluginrc_path))
+ #endif
          strcpy(filename, pluginrc_path);
        else
          sprintf(filename, "%s/%s", gimp_directory(), pluginrc_path);
***************
*** 676,682 ****
--- 684,694 ----
    PlugIn *plug_in;
    char *path;
  
+ #ifndef __EMX__
    if (name[0] != '/')
+ #else
+   if (_fnisrel(name))
+ #endif
      {
        path = search_in_path (plug_in_path, name);
        if (!path)
***************
*** 769,774 ****
--- 781,791 ----
        plug_in->my_write = my_write[1];
        plug_in->his_read = my_write[0];
        plug_in->his_write = my_read[1];
+ #ifdef __EMX__
+       setmode(plug_in->my_read, O_BINARY);
+       setmode(plug_in->my_write, O_BINARY);
+       /* set binary for plug_in->his_read/write is in gimp_main()/libgimp */
+ #endif
  
        /* Remember the file descriptors for the pipes.
         */
***************
*** 794,799 ****
--- 811,817 ----
         *  so that we can later use it to kill the filter if
         *  necessary.
         */
+ #ifndef __EMX__
        plug_in->pid = fork ();
  
        if (plug_in->pid == 0)
***************
*** 808,813 ****
--- 826,842 ----
            _exit (1);
  	}
        else if (plug_in->pid == -1)
+ #else
+       {
+ 	int flag;
+ 	flag = fcntl(plug_in->my_read, F_GETFD);
+ 	fcntl(plug_in->my_read, F_SETFD, flag | FD_CLOEXEC);
+ 	flag = fcntl(plug_in->my_write, F_GETFD);
+ 	fcntl(plug_in->my_write, F_SETFD, flag | FD_CLOEXEC);
+       }
+       plug_in->pid = spawnvp (P_NOWAIT, plug_in->args[0], plug_in->args);
+       if (plug_in->pid == -1)
+ #endif
  	{
            g_message ("unable to run plug-in: %s\n", plug_in->args[0]);
            plug_in_destroy (plug_in);
diff -crN gimp-1.0.0.orig/app/tile_swap.c gimp-1.0.0/app/tile_swap.c
*** gimp-1.0.0.orig/app/tile_swap.c	Sat May 30 15:32:20 1998
--- gimp-1.0.0/app/tile_swap.c	Sun Jul 12 02:45:14 1998
***************
*** 116,121 ****
--- 116,129 ----
  	  tile_swap_print_gaps (def_swap_file);
  	}
  
+ #ifdef __EMX__
+       /* should close before unlink */
+       if (swap_file->fd > 0)
+ 	{
+ 	  close (swap_file->fd);
+ 	  swap_file->fd = -1;
+ 	}
+ #endif
        unlink (swap_file->filename);
      }
  }
diff -crN gimp-1.0.0.orig/app/tips_dialog.c gimp-1.0.0/app/tips_dialog.c
*** gimp-1.0.0.orig/app/tips_dialog.c	Mon Apr 13 19:05:40 1998
--- gimp-1.0.0/app/tips_dialog.c	Thu Jul  9 16:21:14 1998
***************
*** 8,13 ****
--- 8,17 ----
  #include "interface.h"
  #include "wilber.h"
  
+ #ifdef __EMX__
+ extern const char *__XOS2RedirRoot(const char *);
+ #endif
+ 
  #define TIPS_FILE_NAME "gimp_tips.txt"
  
  static int  tips_dialog_hide (GtkWidget *widget, gpointer data);
***************
*** 41,47 ****
--- 45,55 ----
    if (tips_count == 0)
      {
        temp = g_malloc (512);
+ #ifndef __EMX__
        sprintf ((char *)temp, "%s/%s", DATADIR, TIPS_FILE_NAME);
+ #else
+       sprintf ((char *)temp, "%s/%s", __XOS2RedirRoot(DATADIR), TIPS_FILE_NAME);
+ #endif
        read_tips_file ((char *)temp);
        g_free (temp);
      }
diff -crN gimp-1.0.0.orig/config.h gimp-1.0.0/config.h
*** gimp-1.0.0.orig/config.h	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/config.h	Thu Jul  9 16:19:54 1998
***************
*** 0 ****
--- 1,89 ----
+ /* config.h.  Generated automatically by configure.  */
+ /* config.h.in.  Generated automatically from configure.in by autoheader.  */
+ 
+ /* Define if using alloca.c.  */
+ /* #undef C_ALLOCA */
+ 
+ /* Define to one of _getb67, GETB67, getb67 for Cray-2 and Cray-YMP systems.
+    This function is required for alloca.c support on those systems.  */
+ /* #undef CRAY_STACKSEG_END */
+ 
+ /* Define if you have alloca, as a function or macro.  */
+ #define HAVE_ALLOCA 1
+ 
+ /* Define if you have <alloca.h> and it should be used (not on Ultrix).  */
+ #define HAVE_ALLOCA_H 1
+ 
+ /* Define if you don't have vprintf but do have _doprnt.  */
+ /* #undef HAVE_DOPRNT */
+ 
+ /* Define if you have <sys/wait.h> that is POSIX.1 compatible.  */
+ #define HAVE_SYS_WAIT_H 1
+ 
+ /* Define if you have <unistd.h>.  */
+ #define HAVE_UNISTD_H 1
+ 
+ /* Define if you have the vprintf function.  */
+ #define HAVE_VPRINTF 1
+ 
+ /* Define to `int' if <sys/types.h> doesn't define.  */
+ /* #undef pid_t */
+ 
+ /* Define as the return type of signal handlers (int or void).  */
+ #define RETSIGTYPE void
+ 
+ /* If using the C implementation of alloca, define if you know the
+    direction of stack growth for your system; otherwise it will be
+    automatically deduced at run-time.
+  STACK_DIRECTION > 0 => grows toward higher addresses
+  STACK_DIRECTION < 0 => grows toward lower addresses
+  STACK_DIRECTION = 0 => direction of growth unknown
+  */
+ /* #undef STACK_DIRECTION */
+ 
+ /* Define if you have the ANSI C header files.  */
+ #define STDC_HEADERS 1
+ 
+ /* Define if you can safely include both <sys/time.h> and <time.h>.  */
+ #define TIME_WITH_SYS_TIME 1
+ 
+ #define GIMP_MAJOR_VERSION 1
+ #define GIMP_MINOR_VERSION 0
+ #define GIMP_MICRO_VERSION 0
+ #define GIMP_VERSION "1.0.0"
+ 
+ #define HAVE_DIRENT_H 1
+ /* #undef HAVE_DOPRNT */
+ #define HAVE_IPC_H 1
+ /* #undef HAVE_NDIR_H */
+ #define HAVE_SHM_H 1
+ /* #undef HAVE_SYS_DIR_H */
+ /* #undef HAVE_SYS_NDIR_H */
+ /* #undef HAVE_SYS_SELECT_H */
+ #define HAVE_SYS_TIME_H 1
+ #define HAVE_UNISTD_H 1
+ #define HAVE_VPRINTF 1
+ /* #undef HAVE_XSHM_H */
+ 
+ /* #undef IPC_RMID_DEFERRED_RELEASE */
+ 
+ /* #undef NO_DIFFTIME */
+ /* #undef NO_FD_SET */
+ 
+ #define RAND_FUNC random
+ #define SRAND_FUNC srandom
+ 
+ /* #undef PACKAGE */
+ /* #undef VERSION */
+ 
+ /* Define if you have the <dirent.h> header file.  */
+ #define HAVE_DIRENT_H 1
+ 
+ /* Define if you have the <ndir.h> header file.  */
+ /* #undef HAVE_NDIR_H */
+ 
+ /* Define if you have the <sys/dir.h> header file.  */
+ /* #undef HAVE_SYS_DIR_H */
+ 
+ /* Define if you have the <sys/ndir.h> header file.  */
+ /* #undef HAVE_SYS_NDIR_H */
diff -crN gimp-1.0.0.orig/data/brushes/Imakefile gimp-1.0.0/data/brushes/Imakefile
*** gimp-1.0.0.orig/data/brushes/Imakefile	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/data/brushes/Imakefile	Thu Jul  9 23:15:50 1998
***************
*** 0 ****
--- 1,51 ----
+ /*
+     Written for XFree86/OS2
+     Hung-Chi Chu <hcchu@r350.ee.ntu.edu.tw> 07/09/1998
+  */
+ 
+ #include "../../gimp.cf"
+ 
+ brush_DATA	=\
+ 	10x10square.gbr	\
+ 	10x10squareBlur.gbr	\
+ 	11circle.gbr	\
+ 	11fcircle.gbr	\
+ 	13circle.gbr	\
+ 	13fcircle.gbr	\
+ 	15circle.gbr	\
+ 	15fcircle.gbr	\
+ 	17circle.gbr	\
+ 	17fcircle.gbr	\
+ 	19circle.gbr	\
+ 	19fcircle.gbr	\
+ 	1circle.gbr	\
+ 	20x20square.gbr	\
+ 	20x20squareBlur.gbr	\
+ 	3circle.gbr		\
+ 	3fcircle.gbr		\
+ 	5circle.gbr		\
+ 	5fcircle.gbr		\
+ 	5x5square.gbr		\
+ 	5x5squareBlur.gbr	\
+ 	7circle.gbr		\
+ 	7fcircle.gbr		\
+ 	9circle.gbr		\
+ 	9fcircle.gbr		\
+ 	DStar11.gbr		\
+ 	DStar17.gbr		\
+ 	DStar25.gbr		\
+ 	callig1.gbr		\
+ 	callig2.gbr		\
+ 	callig3.gbr		\
+ 	callig4.gbr		\
+ 	confetti.gbr		\
+ 	dunes.gbr		\
+ 	galaxy.gbr		\
+ 	galaxy_big.gbr		\
+ 	galaxy_small.gbr	\
+ 	pixel.gbr		\
+ 	thegimp.gbr		\
+ 	xcf.gbr
+ 
+ InstallMultiple($(brush_DATA),$(GIMPDATADIR)/brushes)
+ 
diff -crN gimp-1.0.0.orig/data/gradients/Imakefile gimp-1.0.0/data/gradients/Imakefile
*** gimp-1.0.0.orig/data/gradients/Imakefile	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/data/gradients/Imakefile	Thu Jul  9 23:22:34 1998
***************
*** 0 ****
--- 1,93 ----
+ /*
+     Written for XFree86/OS2
+     Hung-Chi Chu <hcchu@r350.ee.ntu.edu.tw> 07/09/1998
+  */
+ 
+ #include "../../gimp.cf"
+ 
+ gradient_DATA1	=\
+     Abstract_1 \
+     Abstract_2 \
+     Abstract_3 \
+     Aneurism \
+     Blinds \
+     Blue_Green	\
+     Browns \
+     Brushed_Aluminium \
+     Burning_Paper \
+     Burning_Transparency \
+     CD \
+     CD_Half \
+     Caribbean_Blues \
+     Coffee \
+     Cold_Steel \
+     Cold_Steel_2 \
+     Crown_molding \
+     Dark_1 \
+     Deep_Sea \
+     Default \
+     Flare_Glow_Angular_1 \
+     Flare_Glow_Radial_1 \
+     Flare_Glow_Radial_2 \
+     Flare_Glow_Radial_3	\
+     Flare_Glow_Radial_4	\
+     Flare_Radial_101 \
+     Flare_Radial_102 \
+     Flare_Radial_103 \
+     Flare_Rays_Radial_1 \
+     Flare_Rays_Radial_2 \
+     Flare_Rays_Size_1 \
+     Flare_Sizefac_101 \
+     Four_bars \
+     French_flag \
+     French_flag_smooth \
+     Full_saturation_spectrum_CCW \
+     Full_saturation_spectrum_CW \
+     German_flag \
+     German_flag_smooth \
+     Golden \
+     Greens \
+     Horizon_1 \
+     Horizon_2 \
+     Incandescent \
+     Land_1 \
+     Land_and_Sea
+ 
+ gradient_DATA2	=\
+     Metallic_Something	\
+     Mexican_flag \
+     Mexican_flag_smooth \
+     Nauseating_Headache \
+     Neon_Cyan \
+     Neon_Green \
+     Neon_Yellow \
+     Pastels	\
+     Pastel_Rainbow \
+     Purples \
+     Radial_Eyeball_Blue \
+     Radial_Eyeball_Brown \
+     Radial_Eyeball_Green \
+     Radial_Glow_1 \
+     Radial_Rainbow_Hoop \
+     Romanian_flag \
+     Romanian_flag_smooth \
+     Rounded_edge \
+     Shadows_1 \
+     Shadows_2	\
+     Shadows_3	\
+     Skyline \
+     Skyline_polluted \
+     Square_Wood_Frame \
+     Sunrise	\
+     Three_bars_sin \
+     Tropical_Colors \
+     Tube_Red \
+     Wood_1 \
+     Wood_2	\
+     Yellow_Contrast	\
+     Yellow_Orange
+ 
+ /* since $(DATA) is too long, we split it */
+ InstallMultiple($(gradient_DATA1),$(GIMPDATADIR)/gradients)
+ InstallMultiple($(gradient_DATA2),$(GIMPDATADIR)/gradients)
+ 
diff -crN gimp-1.0.0.orig/data/Imakefile gimp-1.0.0/data/Imakefile
*** gimp-1.0.0.orig/data/Imakefile	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/data/Imakefile	Thu Jul  9 23:13:46 1998
***************
*** 0 ****
--- 1,13 ----
+ /*
+     Written for XFree86/OS2
+     Hung-Chi Chu <hcchu@r350.ee.ntu.edu.tw> 07/09/1998
+  */
+ 
+ #define IHaveSubdirs
+ #define PassCDebugFlags
+ 
+ SUBDIRS = brushes gradients palettes patterns
+ 
+ MakeSubdirs($(SUBDIRS))
+ DependSubdirs($(SUBDIRS))
+ 
diff -crN gimp-1.0.0.orig/data/palettes/Imakefile gimp-1.0.0/data/palettes/Imakefile
*** gimp-1.0.0.orig/data/palettes/Imakefile	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/data/palettes/Imakefile	Thu Jul  9 23:19:16 1998
***************
*** 0 ****
--- 1,47 ----
+ /*
+     Written for XFree86/OS2
+     Hung-Chi Chu <hcchu@r350.ee.ntu.edu.tw> 07/09/1998
+  */
+ 
+ #include "../../gimp.cf"
+ 
+ palette_DATA	=\
+ 	Blues 		\
+ 	Bears		\
+ 	Bgold		\
+ 	Borders		\
+ 	Browns_And_Yellows	\
+ 	Caramel		\
+ 	China		\
+ 	Coldfire	\
+ 	Cool_Colors	\
+ 	Cranes		\
+ 	Dark_pastels	\
+ 	Default		\
+ 	Ega		\
+ 	Firecode	\
+ 	Gold		\
+ 	Grayblue	\
+ 	Grays		\
+ 	GrayViolet	\
+ 	Greens		\
+ 	Hilite		\
+ 	Kahki		\
+ 	Lights		\
+ 	Muted		\
+ 	Named_Colors	\
+ 	News3		\
+ 	Op2		\
+ 	Paintjet	\
+ 	Pastels		\
+ 	Plasma		\
+ 	Reds		\
+ 	Reds_And_Purples	\
+ 	Royal		\
+ 	Topographic	\
+ 	Volcano		\
+ 	Warm_Colors	\
+ 	Web		
+ 
+ InstallMultiple($(palette_DATA),$(GIMPDATADIR)/palettes)
+ 
diff -crN gimp-1.0.0.orig/data/patterns/Imakefile gimp-1.0.0/data/patterns/Imakefile
*** gimp-1.0.0.orig/data/patterns/Imakefile	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/data/patterns/Imakefile	Thu Jul  9 23:20:18 1998
***************
*** 0 ****
--- 1,67 ----
+ /*
+     Written for XFree86/OS2
+     Hung-Chi Chu <hcchu@r350.ee.ntu.edu.tw> 07/09/1998
+  */
+ 
+ #include "../../gimp.cf"
+ 
+ pattern_DATA	=\
+     3dgreen.pat \
+     Craters.pat \
+     Moonfoot.pat \
+     amethyst.pat \
+     bark.pat \
+     blue.pat \
+     bluegrid.pat \
+     bluesquares.pat \
+     blueweb.pat \
+     brick.pat \
+     burlap.pat \
+     burlwood.pat \
+     choc_swirl.pat \
+     corkboard.pat \
+     cracked.pat    \
+     crinklepaper.pat \
+     electric.pat \
+     fibers.pat	\
+     granite1.pat \
+     ground1.pat \
+     ice.pat \
+     java.pat \
+     leather.pat \
+     leaves.pat \
+     leopard.pat \
+     lightning.pat \
+     marble1.pat \
+     marble2.pat \
+     marble3.pat \
+     nops.pat \
+     paper.pat \
+     parque1.pat \
+     parque2.pat \
+     parque3.pat \
+     pastel.pat \
+     pine.pat \
+     pink_marble.pat \
+     pool.pat \
+     qube1.pat \
+     rain.pat \
+     recessed.pat \
+     redcube.pat \
+     rock.pat \
+     sky.pat \
+     slate.pat \
+     sm_squares.pat \
+     starfield.pat \
+     stone33.pat   \
+     terra.pat \
+     walnut.pat \
+     warning.pat \
+     wood1.pat \
+     wood2.pat \
+     wood3.pat \
+     wood4.pat \
+     wood5.pat 
+ 
+ InstallMultiple($(pattern_DATA),$(GIMPDATADIR)/patterns)
+ 
diff -crN gimp-1.0.0.orig/gimp.cf gimp-1.0.0/gimp.cf
*** gimp-1.0.0.orig/gimp.cf	Thu Jan  1 00:00:00 1970
--- gimp-1.0.0/gimp.cf	Sat Sep 12 21:38:02 1998
***************
*** 0 ****
--- 1,13 ----
+ /*
+     Written for XFree86/OS2
+     Hung-Chi Chu <hcchu@r350.ee.ntu.edu.tw> 07/09/1998
+  */
+ 
+ #define BuildOMFEXE 1	/* reduce EXE size */
+ 
+ GIMPDIR = $(LIBDIR)/gimp
+ 
+ GIMPPLUGINSDIR = $(GIMPDIR)/plug-ins
+ 
+ GIMPDATADIR = $(GIMPDIR)/data
+ 
